#include "CScreenQuadCB.hpp"

using namespace irr;
using namespace core;
using namespace video;



CScreenQuadWithShader::CScreenQuadWithShader()
{
	Material.Wireframe = false;
    Material.Lighting = false;
    Material.ZWriteEnable = false;
    Material.BackfaceCulling = false;
//    Material.ZBuffer = video::ECFN_ALWAYS;  //! depth test alway succeds

    // Upper left vertice
    Vertices[0] = S3DVertex(vector3df(-1.f, 1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(0, 0));
    Vertices[1] = S3DVertex(vector3df(1.f, 1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(1, 0));
    Vertices[2] = S3DVertex(vector3df(1.f, -1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(1, 1));
    Vertices[3] = S3DVertex(vector3df(-1.f, -1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(0, 1));

    //! backup vertices
//    Vertices[0] = S3DVertex(vector3df(-1.f, 1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(0, 0));
//    Vertices[1] = S3DVertex(vector3df(1.f, 1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(1, 0));
//    Vertices[2] = S3DVertex(vector3df(1.f, -1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(1, 1));
//    Vertices[3] = S3DVertex(vector3df(-1.f, -1.f, 0), vector3df(0, 0, 1.f), SColor(255,255,255,255), vector2df(0, 1));

    Indices[0] = 0;
    Indices[1] = 1;
    Indices[2] = 3;
    Indices[3] = 1;
    Indices[4] = 2;
    Indices[5] = 3;


    // S3DVertex(f32 x, f32 y, f32 z, f32 nx, f32 ny, f32 nz, SColor c, f32 tu, f32 tv)


}


void CScreenQuadWithShader::render(irr::video::IVideoDriver* driver
//                                   , const core::rectf& destRect
                                   , const core::position2di& pos
//                                   , const core::dimension2du& dims
                                   ,  video::ITexture* texture
                                   )
{

    core::dimension2d<u32> screenSize = driver->getScreenSize();

//    core::rectf& destRect;
    const core::dimension2du& dims( texture->getSize() );
    core::vector2di absPosUpperLeft ( pos );
    core::vector2di absPosLowerRight ( pos );

    // TODO penser  a interpolate ?
    absPosLowerRight.X += dims.Width;
    absPosLowerRight.Y += dims.Height;
//    core::vector2df relPos ( pos );

    core::recti destRect (pos, dims);
    auto UpperLeftCorner = destRect.UpperLeftCorner;
auto    LowerRightCorner = destRect.LowerRightCorner;

//    vector2df UpperLeftCorner( -1.f + 2.f*( (float)absPosUpperLeft.X/(float)screenSize.Width)  ,  -1.f + 2.f*( (float)absPosUpperLeft.Y/(float)screenSize.Height)  );
//    vector2df LowerRightCorner( -1.f + 2.f*( (float)absPosLowerRight.X/(float)screenSize.Width)  ,  -1.f + 2.f*( (float)absPosLowerRight.Y/(float)screenSize.Height)  );

//    vector2df LowerRightCorner( UpperLeftCorner + )


    const core::dimension2d<u32>& renderTargetSize = driver->getCurrentRenderTargetSize();

    // all set to 0 EM4CONST_IDENTITY
//    core::matrix4 m(core::matrix4::Identity);
    core::matrix4 m(core::matrix4::EM4CONST_NOTHING);
    m.buildProjectionMatrixOrthoLH(f32(renderTargetSize.Width), f32(-(s32)(renderTargetSize.Height)), -1.0f, 1.0f);
    m.setTranslation( core::vector3df( -1.f,1.f,0.f)) ;
    driver->setTransform(ETS_WORLD, m);
    // we don't care about the projection matrix since we won't use it
//    driver->setTransform(video::ETS_PROJECTION, core::IdentityMatrix);
    driver->setTransform(video::ETS_VIEW, core::IdentityMatrix);

    Vertices[0].Pos.set( UpperLeftCorner.X, UpperLeftCorner.Y, 0);
    Vertices[1].Pos.set( LowerRightCorner.X, UpperLeftCorner.Y , 0 );
    Vertices[2].Pos.set( LowerRightCorner.X, LowerRightCorner.Y , 0);
    Vertices[3].Pos.set( UpperLeftCorner.X, LowerRightCorner.Y , 0 );

    Material.setTexture(0, texture );
    driver->setMaterial(Material);

    driver->drawIndexedTriangleList( Vertices, 4, Indices, 2);
}
