/**
\file config_manager.h

Refaire pour l'adapter avec le systeme de boost::program_options
*/
#ifndef _BC_CBindCollectionPlayer_HPP_INCLUDED
#define _BC_CBindCollectionPlayer_HPP_INCLUDED


#include <irrlicht.h>  // header only
#include <array>
#include <fusion/logging/ILogger.hpp>
#include <boost/bimap.hpp>
#include <boost/optional.hpp>
#include <boost/noncopyable.hpp>
#include <map>
#include <fusion/utilities/SBimap.hpp>
#include "CBindDescriptor.hpp"
//#include "CInputManager.hpp"

#include "../def.hpp"
#include <boost/bimap/bimap.hpp>
#include <boost/bimap/list_of.hpp>
#include <boost/bimap/unordered_set_of.hpp>
#include <boost/bimap/vector_of.hpp>
#include <vector>
#include "CBindDescriptor.hpp"
#include "IBindCollection.hpp"
#include "SCachedState.hpp"
#include "../def.hpp"
#include <irrlicht.h>

namespace bbi = boost::bimaps;



// Passer le TFullId en parametre
class CBindCollectionPlayer :
    public IBindCollection< NPlayerInput::TBindId, NPlayerInput::EId >
{

protected:
    TTimeUnit LastUpdatedTime;

// TODO should be an array
    typedef std::map< TFullId , CBindDescriptor> TDescriptorList;
//    typedef std::array<CBindDescriptor, NPlayerInput::Count> TDescriptorList;

    TDescriptorList _descriptors;
public:

    CBindCollectionPlayer(   );

    const CBindDescriptor& getBind(TFullId const& id)
    {
        return _descriptors[id];
        //.Descriptor;
    }

//    const CBindDescriptor& getBind(TFullId const& id) const

    /**
    Return vector of ids and of size < limit matching the descriptor. Useful to check if a descriptor was already registered

    **/
    std::vector<TFullId>
    getAssociatedIds( CBindDescriptor const& descriptor, std::size_t const& limit) const;


    void removeBind(TFullId const& id);
    // TODO for descriptor
    //void removeBinds(TBindId const& id);


    /**
    Returns identifier matching current "id" mode with descriptor
    ,ETapMode const& = ETapMode::JustPressed
    // = -1
    **/
    //,TParam const& param
    CBindDescriptor&
    setBind(TFullId const& id,CBindDescriptor const& descriptor);

//    NPlayerInput::EId, int

    /**
    \returns Id of matching descriptor/mode if exists, otherwise returns unitialiazed
    //, ETapMode const& mode
    **/
    //TOptionalFullId
    bool containBind(CBindDescriptor const& descriptor, TFullId& id);



    /**
    Must be called on a regular basis to check if autoRepeat triggers some events
    **/
//    void updateCache( TTimeUnit const& currentTime);
    void updateCache( irr::IInputManager* inputMgr, TCache& cache) const;



};



#endif
