#include "debug.hpp"
#include <fusion/fusion.hpp>
#include <algorithm>


//void generateSceneList( irr::gui::IGUIElement* root, TTempAssociation& result)

void generateGuiList( irr::gui::IGUIElement* root, TTempAssociation& result)
{
//    result.clear();
    if( root == 0){
        return;
    }

//    const core::list<IGUIElement*>& children = root->getChildren();
    //! for each child, register it
    irr::core::list<irr::gui::IGUIElement*>::ConstIterator it = root->getChildren().begin();
    for(; it != root->getChildren().end();it++ )
    {
//        logger << *it;
//        printSceneManager(*it);
        generateGuiList(*it,result);

    }


    result.insert( std::make_pair(root, root->getParent() ) );
//    _INFO << "Inserted gui element " << root << " with parent " << root->getParent() ;
}


//std::list<irr::gui::IGUIElement*>
void compareLists(const TTempAssociation& p1,const TTempAssociation& p2, TTempAssociation& result)
{

    std::set_symmetric_difference(p1.begin(), p1.end(),
                                 p2.begin(), p2.end(),
                                 std::inserter( result, result.begin() )
                                 );

}




void printSceneManager(const irr::scene::ISceneNode* scene)
{
    if(scene == 0){
        _INFO << " Scene node == 0 ";
//        return logger;
    }


    _INFO << " Scene node: " << scene->getName();
    irr::core::list<irr::scene::ISceneNode*>::ConstIterator it = scene->getChildren().begin();
    for(; it != scene->getChildren().end();it++ )
    {
//        logger << *it;
        printSceneManager(*it);
    }

//    return logger;
}
